## ball 1.4.3~beta1

=== CMakeLists.txt ===
# CMake configuration for BALL (http://www.ball-project.org)
#
# This file is - on purpose - heavily based on the CMake configuration
# of OpenMS (http://www.openms.de) to optimize synergy effects

PROJECT("BALL")

# TODO LIST:
#   BALL specific:
#
#   inherited from OpenMS:
#			- test for contrib headers (CONTRIB_HEADER_DIR ccmake variable - test one header for each required library)
#			- parallel build of test executables
#			- target to execute all EXAMPLES

########################################################
### entries meant to be configured using CMake cache ###
### - do NOT hardcode them here!										 ###
### - edit them within CMakeCache.txt using ccmake	 ###
########################################################
# CONTRIB_CUSTOM_DIR
# STL_DEBUG
# QT_DB_PLUGIN

########################################################
###    manual entries (edit this for new release)    ###
########################################################

SET(BALL_PACKAGE_VERSION_MAJOR "1")
SET(BALL_PACKAGE_VERSION_MINOR "4")
SET(BALL_PACKAGE_VERSION_PATCH "79")

########################################################
###    end manual	entries													   ###
########################################################

# Heart of the BUILD system : only edit when you know what you�re doing (we don�t)
# quick manual for most commands: http://www.cmake.org/cmake/help/cmake2.6docs.html
# useful predefined variables: http://www.paraview.org/Wiki/CMake_Useful_Variables

CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)

SET(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)

SET(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE TRUE)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

OPTION(BALL_USE_PROJECT_FOLDERS ON)
IF (BALL_USE_PROJECT_FOLDERS)
	SET(USE_FOLDERS TRUE)
ENDIF()

SET(CF_BALL_PACKAGE_VERSION "${BALL_PACKAGE_VERSION_MAJOR}.${BALL_PACKAGE_VERSION_MINOR}.${BALL_PACKAGE_VERSION_PATCH}" CACHE INTERNAL "BALL VERSION" FORCE)

# Initialize the various PREFIX variables. This has to happen before any files
# using them are included.
#SET(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "Installation prefix for BALL")

## default build type (for Makefile generators): Release
## TODO: 64 Bit builds etc for Windows
IF(BALL_BUILD_TYPE)
	MESSAGE(WARNING "The BALL_BUILD_TYPE should no longer be used. Use CMAKE_BUILD_TYPE instead")
	SET(CMAKE_BUILD_TYPE ${BALL_BUILD_TYPE})
ENDIF()

## if no build type is given, default to Release
IF(NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE Release)
ENDIF()

SET(BALL_CONTRIB_PATH "" CACHE PATH "Path to the contrib directory, if installed (optional)")
SET(CMAKE_PREFIX_PATH ${BALL_CONTRIB_PATH} ${CMAKE_PREFIX_PATH})

IF(UNIX AND BALL_CONTRIB_PATH)
	SET(CMAKE_LIBRARY_PATH ${BALL_CONTRIB_PATH}/lib ${BALL_CONTRIB_PATH}/lib64 ${CMAKE_LIBRARY_PATH})
	SET(CMAKE_INCLUDE_PATH ${BALL_CONTRIB_PATH}/include ${CMAKE_INCLUDE_PATH})
ENDIF()

SET(CMAKE_REQUIRED_INCLUDES ${BALL_CONTRIB_PATH}/include ${CMAKE_REQUIRED_INCLUDES})

SET(BALL_TEST_DATA_PATH ${PROJECT_SOURCE_DIR}/source/TEST/data)
SET(BALL_BENCHMARK_DATA_PATH ${PROJECT_SOURCE_DIR}/source/BENCHMARKS/data)

# Should we build packages as well?
OPTION(BALL_ENABLE_PACKAGING "Enable the building of binary packages" OFF)

# Used for linking BALL dependent applications and libraries (BALLView, Python bindings, ...)
SET(BALL_LIBRARIES optimized BALL debug BALLd)
SET(VIEW_LIBRARIES optimized VIEW debug VIEWd)

# some of our own macros (BALL_CHECKLIB, QT4_WRAP_UI_OWN, ...)
INCLUDE(cmake/BALLMacros.cmake)
INCLUDE(cmake/BALLCompilerSpecific.cmake)
INCLUDE(cmake/BALLConfiguration.cmake)
INCLUDE(cmake/BALLComponents.cmake)

## additional include directories
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include/) ## for configured files, i.e. config.h
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include/)
IF (BALL_CONTRIB_PATH)
	INCLUDE_DIRECTORIES(${BALL_CONTRIB_PATH}/include/)
ENDIF()

## Extra libraries we want to link into BALL
SET(BALL_DEP_LIBRARIES)
SET(VIEW_DEP_LIBRARIES)

## Flex and Bison
## This ugly hack is required as long as we cannot tell cmake to set an environment variable for bison...
IF (WIN32)
	FIND_PROGRAM(BISON_EXECUTABLE BALL-bison.bat DOC "path to the bison executable")
ENDIF()
FIND_PACKAGE(BISON)
IF (NOT BISON_FOUND)
	MESSAGE(SEND_ERROR "Could not find bison parser generator!")
ENDIF()

IF (WIN32)
	SET(BALL_BISON_BAT ${BISON_EXECUTABLE})
	SET(BISON_EXECUTABLE "call")
ENDIF()

FIND_PACKAGE(FLEX)
IF (NOT FLEX_FOUND)
	MESSAGE(SEND_ERROR "Could not find flex scanner generator!")
ENDIF()
## Figure out if the used flex version supports ...lex_destroy()
MESSAGE(STATUS "Checking for yylex_destroy support in flex")
STRING(REGEX REPLACE "^([0-9]+)\\.([0-9]+)\\.([0-9]+).*$" "\\1;\\2;\\3"
	FLEX_VERSION_NUMERIC ${FLEX_VERSION})
LIST(GET FLEX_VERSION_NUMERIC 2 FLEX_PATCH_LEVEL)
IF (FLEX_PATCH_LEVEL GREATER 8)
	MESSAGE(STATUS "Checking for yylex_destroy support in flex - found")
	SET(BALL_HAS_YYLEX_DESTROY TRUE)
ELSE()
	MESSAGE(STATUS "Checking for yylex_destroy support in flex - Not found")
	SET(BALL_HAS_YYLEX_DESTROY FALSE)
ENDIF()

## Third-party libraries ##

## XDR related stuff
FIND_PACKAGE(XDR)
IF (XDR_FOUND)
	INCLUDE(cmake/BALLConfigXDR.cmake)
ENDIF()

## Boost and Asio
INCLUDE(cmake/BALLConfigBoost.cmake)
INCLUDE_DIRECTORIES(${BOOST_INCLUDE_DIRS})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
LIST(APPEND BALL_DEP_LIBRARIES ${BOOST_LIBRARIES})
# make the rest of CMake aware of boost's existence
LIST(APPEND CMAKE_REQUIRED_INCLUDES ${BOOST_INCLUDE_DIRS})

## Check for the boost::unordered_map implementation
INCLUDE(cmake/BALLConfigHashMap.cmake)

## GSL
OPTION(USE_GSL "Link against the GNU scientific library is available" TRUE)

SET(BALL_HAS_GSL FALSE)
IF(USE_GSL)
	FIND_PACKAGE(GSL)
	IF (GSL_FOUND)
		ADD_DEFINITIONS(${CMAKE_GSL_CXX_FLAGS})
		INCLUDE_DIRECTORIES(${GSL_INCLUDE_DIR})
		LIST(APPEND BALL_DEP_LIBRARIES ${GSL_LIBRARIES})
		SET(BALL_HAS_GSL TRUE)
	ENDIF()
ENDIF()

## FFTW
OPTION(USE_FFTWD "Use double precision FFTW if found" ON)
OPTION(USE_FFTWF "Use single precision FFTW if found" ON)
OPTION(USE_FFTWF "Use long double precision FFTW if found" ON)
OPTION(USE_FFTW_THREADS "Try to find FFTW with thread support" OFF)

FIND_PACKAGE(FFTW)
IF(FFTW_FOUND)
	INCLUDE(cmake/BALLConfigFFTW.cmake)
ENDIF()

#Set the default complex precision to float if the setting for this value
#could not be determined earlier
IF(NOT BALL_COMPLEX_PRECISION)
	SET(BALL_COMPLEX_PRECISION "float")
ENDIF()

## lpsolve
OPTION(USE_LPSOLVE "Compile with lpsolve support, if lpsolve can be found" ON)

FIND_PACKAGE(LPSolve)
IF (LPSOLVE_FOUND)
	SET(BALL_HAS_LPSOLVE TRUE)
	INCLUDE_DIRECTORIES(${LPSOLVE_INCLUDE_DIR})
ENDIF()


## libsvm
OPTION(USE_LIBSVM "Compile with libsvm support if libsvm can be found" ON)

#this setting crashes cmake when libSVM is installed
#FIND_PACKAGE(libSVM)
#IF (LIBSVM_FOUND)
#	SET(BALL_HAS_LIBSVM TRUE)
#	INCLUDE_DIRECTORIES(${LIBSVM_INCLUDE_DIRS})
## ENDIF()

IF(USE_LIBSVM)
  FIND_PACKAGE(libSVM)
  IF (LIBSVM_FOUND)
  SET(BALL_HAS_LIBSVM TRUE)
  INCLUDE_DIRECTORIES(${LIBSVM_INCLUDE_DIRS}) 
  ENDIF()
ENDIF()

## CUDA
SET(USE_CUDA OFF CACHE BOOL "Should CUDA support be enabled (version <= 2.1 currently supported)?")

IF(USE_CUDA)
	FIND_PACKAGE(CUDA REQUIRED)
ENDIF()

## TBB
SET(USE_TBB ON CACHE BOOL "Should Intel Threading Building Blocks support be enabled?")
SET(REQUIRE_TBB OFF CACHE BOOL "Should Intel Threading Building Blocks support be required?")

## RTFact would require tbb... so check if it is required
IF(REQUIRE_RTFACT)
	SET(REQUIRE_TBB ON)
ENDIF()

IF(USE_TBB)
	IF (REQUIRE_TBB)
		FIND_PACKAGE(TBB REQUIRED)
	ELSE()
		FIND_PACKAGE(TBB)
		IF (NOT TBB_FOUND)
			MESSAGE(STATUS "Intel Threading Building Blocks not found!")
		ENDIF()
	ENDIF()

	IF (TBB_FOUND)
		INCLUDE_DIRECTORIES(${TBB_INCLUDE_DIRS})
		BALL_COMBINE_LIBS(TBB_LIBRARIES "${TBB_LIBRARIES}" "${TBB_DEBUG_LIBRARIES}")
		LIST(REMOVE_DUPLICATES TBB_LIBRARIES)

		SET(BALL_HAS_TBB TRUE)
	ENDIF()
ENDIF()

## MPI
OPTION(USE_MPI "Should MPI support be enabled?" ON)
OPTION(REQUIRE_MPI "Should MPI support be required?" OFF)

IF (USE_MPI)
	IF (REQUIRE_MPI)
		FIND_PACKAGE(MPI REQUIRED)
	ELSE()
		FIND_PACKAGE(MPI)
	ENDIF()

	IF (MPI_FOUND)
		ADD_DEFINITIONS(${MPI_CXX_COMPILE_FLAGS})
		INCLUDE_DIRECTORIES(${MPI_CXX_INCLUDE_PATH})

		SET(BALL_HAS_MPI TRUE)
	ENDIF()

ENDIF()

## VIEW related options/settings/libraries
OPTION(BALL_HAS_VIEW "Compile BALL's VIEW library required for visualization and graphical user interfaces" ON)

## QT
OPTION(USE_QTSQL "Compile BALL's database adapaters (requires QtSql)" ON)
OPTION(USE_QTWEBKIT "Add support for QWebkit" ${BALL_HAS_VIEW})

IF(NOT BALL_HAS_VIEW)
	MESSAGE(WARNING "Warning: CMakes Qt4 find macro is too restrictive and requires UIC and RCC to be present. "
	                "If you are building without the GUI part of Qt installed, you will need to create dummy files "
	                "for both executables in the Qt prefix path.")
ENDIF()

FIND_PACKAGE(Qt4 REQUIRED)

SET(QT_USE_QTXML TRUE)
SET(QT_USE_QTNETWORK TRUE)
SET(QT_USE_QTSQL    ${USE_QTSQL})

# Qt Dependencies for VIEW
IF(BALL_HAS_VIEW)
	SET(QT_USE_QTOPENGL   TRUE)
	SET(QT_USE_QTTEST     TRUE)

	IF(USE_QTWEBKIT)
		SET(QT_USE_QTWEBKIT TRUE)
		SET(QT_USE_PHONON   TRUE)
	ENDIF()
ELSE()
	SET(QT_DONT_USE_QTGUI TRUE)
ENDIF()


SET(QT_MIN_VERSION "4.4.0")

INCLUDE(${QT_USE_FILE})

SET(BALL_HAS_QTWEBKIT TRUE)
IF(USE_QTWEBKIT AND NOT QT_QTWEBKIT_FOUND)
	SET(BALL_HAS_QTWEBKIT FALSE)
	MESSAGE(STATUS "QtWebkit has not been found. Disabling browser support.")
ENDIF()

## On Windows, we might need to explicitly deploy openssl libraries for Qt
IF(WIN32)
	FIND_PATH(QT_SSLEAY_LIB NAME ssleay32.dll PATHS ${QT_BINARY_DIR} NO_DEFAULT_PATH)
	IF(QT_SSLEAY_LIB)
		LIST(APPEND QT_LIBRARIES ${QT_SSLEAY_LIB}/ssleay32.dll)
	ENDIF()

	FIND_PATH(QT_LIBEAY_LIB NAME libeay32.dll PATHS ${QT_BINARY_DIR} NO_DEFAULT_PATH)
	IF(QT_SSLEAY_LIB)
		LIST(APPEND QT_LIBRARIES ${QT_LIBEAY_LIB}/libeay32.dll)
	ENDIF()
ENDIF()

MESSAGE(STATUS "QT qmake at ${QT_QMAKE_EXECUTABLE}")
MESSAGE(STATUS "QT moc at ${QT_MOC_EXECUTABLE}")
MESSAGE(STATUS "QT uic at ${QT_UIC_EXECUTABLE}")

SET(EIGEN3_VERSION_OK "3.0.0")
FIND_PACKAGE(Eigen3 REQUIRED)
INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIR})


## VIEW dependent packages
IF (BALL_HAS_VIEW)

	## VIEW dependent options
	OPTION(BALL_ENABLE_CG "Build against NVIDIA Cg library" OFF)
	OPTION(BALL_REQUIRE_CG "Fail if NVIDIA Cg could not be detected" OFF)

	OPTION(USE_RTFACT "Enable RTfact support" ON)
	OPTION(REQUIRE_RTFACT "Require RTfact support" OFF)

	## OpenGL
	FIND_PACKAGE(OpenGL)
	IF (NOT OPENGL_FOUND OR NOT OPENGL_GLU_FOUND)
		MESSAGE(SEND_ERROR "Could not find gl/glu!")
	ENDIF()

	## GLEW
	FIND_PACKAGE(GLEW)
	IF (GLEW_FOUND)
		SET(BALL_HAS_GLEW TRUE)
	ENDIF()

	## RTfact
	IF (USE_RTFACT)
		IF (REQUIRE_RTFACT)
			FIND_PACKAGE(RTfact REQUIRED)
		ELSE()
			FIND_PACKAGE(RTfact)
		ENDIF()

		IF (RTFACT_FOUND)
			## RTfact requires TBB
			IF (NOT CMAKE_COMPILER_IS_INTELCXX)
				IF (NOT TBB_FOUND)
					MESSAGE(SEND_ERROR "RTfact support requires TBB!")
				ENDIF()
			ENDIF()

			SET(BALL_HAS_RTFACT TRUE)
			INCLUDE_DIRECTORIES(${RTFACT_INCLUDE_DIR})
		ENDIF()
	ENDIF()

	## Cg
	IF (BALL_ENABLE_CG)
		IF (BALL_REQUIRE_CG)
			SET(CG_MESSAGE "Looking for Cg library (required)...")
		ELSE()
			SET(CG_MESSAGE "Looking for Cg library...")
		ENDIF()

		MESSAGE(STATUS ${CG_MESSAGE})
		FIND_PACKAGE(Cg)

		IF (CG_FOUND)
			MESSAGE(STATUS "${CG_MESSAGE} - found  ${CG_LIBRARY}  ${CG_GL_LIBRARY}")
			SET(BALL_HAS_CG TRUE)
			SET(CG_LIBRARIES ${CG_LIBRARY} ${CG_GL_LIBRARY})
			INCLUDE_DIRECTORIES(${RTFACT_INCLUDE_PATH})
		ELSE()
			IF (BALL_REQUIRE_CG)
				MESSAGE(SEND_ERROR "Could not find Cg library, but Cg was marked as required!")
			ELSE()
				MESSAGE(STATUS "Disabling Cg support")
			ENDIF()
		ENDIF()
	ENDIF(BALL_ENABLE_CG)

ENDIF(BALL_HAS_VIEW)

## Python
OPTION(BALL_PYTHON_SUPPORT "Compile BALL's python interface (requires python development packages)" ON)

IF (BALL_PYTHON_SUPPORT)

=== source/EXTENSIONS/CMakeLists.txt ===
PROJECT(BALL_PLUGINS)

OPTION(USE_PRESENTABALL_PLUGIN "Build the PresentaBALL plugin" ON)
OPTION(USE_XML3D_PLUGIN "Build the XML3D plugin" ON)
OPTION(USE_SPACENAV_PLUGIN "Build the SpaceNavigator input device plugin" ON)
OPTION(USE_VRPN_PLUGIN "Build the VRPN input device plugin" ON)
OPTION(USE_VRPNHD_PLUGIN "Build the VRPNDH input device plugin" ON)
OPTION(USE_BALLAXY_PLUGIN "Build the BALLaxy widget plugin" ON)

IF (USE_PRESENTABALL_PLUGIN)
	ADD_SUBDIRECTORY(PRESENTABALL)
ENDIF()

IF (USE_SPACENAV_PLUGIN)
	ADD_SUBDIRECTORY(SPACENAV)
ENDIF()

IF (USE_XML3D_PLUGIN)
	ADD_SUBDIRECTORY(XML3D)
ENDIF()

IF (USE_VRPN_PLUGIN)
	ADD_SUBDIRECTORY(VRPN)
ENDIF()

IF (USE_VRPNHD_PLUGIN)
	ADD_SUBDIRECTORY(VRPNHD)
ENDIF()

IF (USE_BALLAXY_PLUGIN)
	ADD_SUBDIRECTORY(BALLAXY)
ENDIF()

=== source/TEST/CMakeLists.txt ===
### Build rules for BALL's class tests
PROJECT("BALL_tests")

ENABLE_TESTING()

OPTION(BALL_TEST_VERBOSE "Use verbose output for the tests" ON)

SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/TEST)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

## For now, disable optimization for the tests
IF (CMAKE_COMPILER_IS_INTELCXX OR CMAKE_COMPILER_IS_GNUCXX)
	SET(CMAKE_CXX_FLAGS_RELEASE_SAVED ${CMAKE_CXX_FLAGS_RELEASE})
	SET(CMAKE_CXX_FLAGS_RELEASE "-O0")
ENDIF()

## On 32 Bit Windows, disable optimization for the tests
IF(CMAKE_GENERATOR STREQUAL "Visual Studio 10")
	SET(CMAKE_CXX_FLAGS_RELEASE_SAVED ${CMAKE_CXX_FLAGS_RELEASE})
	SET(CMAKE_CXX_FLAGS_RELEASE "-O0")
ENDIF()

INCLUDE(cmake/BALLTestExecutables.cmake)
INCLUDE(cmake/VIEWTestExecutables.cmake)

## BASIC
ADD_CUSTOM_TARGET(BASIC_TEST)
ADD_DEPENDENCIES(BASIC_TEST ${BALL_BASIC_TESTS})

## MATHS
ADD_CUSTOM_TARGET(MATHS_TEST)
ADD_DEPENDENCIES(MATHS_TEST ${BALL_MATHS_TESTS})

## SYSTEM
ADD_CUSTOM_TARGET(SYSTEM_TEST)
ADD_DEPENDENCIES(SYSTEM_TEST ${BALL_SYSTEM_TESTS})

## TODO: all of them...

## Restore build flags
IF (CMAKE_COMPILER_IS_INTELCXX OR CMAKE_COMPILER_IS_GNUCXX)
	SET(${CMAKE_CXX_FLAGS_RELEASE} ${CMAKE_CXX_FLAGS_RELEASE_SAVED})
ENDIF()

SET(BALLTEST_SUPPORT_LIBRARIES "")
IF (UNIX)
	LIST(APPEND BALLTEST_SUPPORT_LIBRARIES "pthread")
ENDIF ()

# Now, add all tests as targets
SET(ALL_TESTS "")
FOREACH(group ${BALL_TESTS})
	FOREACH(test ${${group}})
		ADD_EXECUTABLE(${test} ${test}.C)
		TARGET_LINK_LIBRARIES(${test} BALL ${BALLTEST_SUPPORT_LIBRARIES})
		SET_PROPERTY(TARGET ${test} PROPERTY FOLDER ${group})
		IF (NOT BALL_TEST_VERBOSE)
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test})
		ELSE()
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test} "-v")
		ENDIF()
		LIST(APPEND ALL_TESTS ${test})
	ENDFOREACH()
ENDFOREACH()

# Set the timeout of some tests to 2h
# This is needed for the memcheck running on the CI server
# which takes _very_ long
SET_TESTS_PROPERTIES (
	ScoringFunction_test
	AssignBondOrderProcessor_test
	PROPERTIES TIMEOUT 7200
)

IF (BALL_HAS_VIEW)
	FOREACH(test ${VIEW_TESTS})
		ADD_EXECUTABLE(${test} ${test}.C)
		TARGET_LINK_LIBRARIES(${test} BALL VIEW ${BALLTEST_SUPPORT_LIBRARIES})
		SET_PROPERTY(TARGET ${test} PROPERTY FOLDER BALL_VIEW_TESTS)
		IF (NOT BALL_TEST_VERBOSE)
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test})
		ELSE()
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test} "-v")
		ENDIF()
	ENDFOREACH()

	LIST(APPEND ALL_TESTS ${VIEW_TESTS})
ENDIF()

# Create a suitable target
ADD_CUSTOM_TARGET(build_tests)
ADD_DEPENDENCIES(build_tests ${ALL_TESTS})

=== source/APPLICATIONS/QuEasyRun/CMakeLists.txt ===
PROJECT(QueEasyRun)

FIND_PACKAGE(Qwt5)

IF(NOT Qwt5_Qt4_FOUND)
	RETURN()
ENDIF()

### list all filenames of the directory here ###
SET(SOURCES_LIST
#	featureSelector.C
#	inputPartitioner.C
#	inputReader.C
	main.C
#	modelCreator.C
#	predictor.C
#	validator.C
)

IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
# TODO: Use an icon for QuEasy
	LIST(APPEND RESOURCES_LIST ${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns)
	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns
			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
ENDIF()

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR} ${Qwt5_INCLUDE_DIR})

ADD_DEFINITIONS(-DEXT_MAIN)

ADD_EXECUTABLE(QuEasyRun
	${SOURCES_LIST}
	${RESOURCES_LIST}
)

IF (WIN32)
	SET_TARGET_PROPERTIES(QuEasyRun PROPERTIES WIN32_EXECUTABLE TRUE)
ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	SET_TARGET_PROPERTIES(QuEasyRun PROPERTIES MACOSX_BUNDLE TRUE)
ENDIF()

TARGET_LINK_LIBRARIES(QuEasyRun BALL)

INSTALL(TARGETS QuEasyRun
	COMPONENT "${COMPONENT_QUEASY}"
	RUNTIME DESTINATION "${BALL_RUNTIME_INSTALL_DIRECTORY}"
	BUNDLE DESTINATION "${BALL_BUNDLE_INSTALL_DIRECTORY}"
)

#INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/QuEasyRun
#	DESTINATION "${BALL_DOCUMENTATION_INSTALL_DIRECTORY}" 
#	COMPONENT "${COMPONENT_QUEASY}"
#)

#INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/BALLView 
#	DESTINATION "${BALL_DOCUMENTATION_INSTALL_DIRECTORY}" 
#	COMPONENT "${COMPONENT_BALLVIEW}"
#)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	GET_FILENAME_COMPONENT(MACDEPLOYQT_EXECUTABLE "${QT_QMAKE_EXECUTABLE}" PATH)
	SET(MACDEPLOYQT_EXECUTABLE "${MACDEPLOYQT_EXECUTABLE}/macdeployqt")
	INSTALL(CODE "SET(MACDEPLOYQT_EXECUTABLE \"${MACDEPLOYQT_EXECUTABLE}\")" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(FIXBUNDLE ${CMAKE_SOURCE_DIR}/MacOSX/fixbundleframeworks.sh)" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(BALLVIEW_BUNDLE \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${BALL_BUNDLE_INSTALL_DIRECTORY}/QuEasyRun.app\")" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(CMAKE_SOURCE_DIR ${CMAKE_SOURCE_DIR})" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(SCRIPT "${CMAKE_SOURCE_DIR}/cmake/BALLViewCreateBundle.cmake" COMPONENT "${COMPONENT_QUEASY}")
ENDIF()

=== source/APPLICATIONS/QuEasyViz/CMakeLists.txt ===
PROJECT(QuEasyViz)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured not to build the VIEW components. Diabling QuEasyViz.")
	RETURN()
ENDIF()

FIND_PACKAGE(Qwt5)

IF(NOT Qwt5_Qt4_FOUND)
	RETURN()
ENDIF()

### list all filenames of the directory here ###
SET(SOURCES_LIST
	bayesPlotter.C
	coefficientPlotter.C
	componentPlotter.C
	connectionManager.C
	CSVInputDataItem.C
	CSVInputDialog.C
	dataItem.C
	dataItemScene.C
	dataItemView.C
	dottedEdge.C
	edge.C
	exception.C
	featurePlotter.C
	featureSelectionDialog.C
	featureSelectionItem.C
	fileBrowser.C
	inputDataDialog.C
	inputDataItem.C
	inputDataItemIO.C
	inputPartitionItem.C
	inputPlotter.C
	main.C
	mainWindow.C
	modelConfigurationDialog.C
	modelConfigurationDialogPages.C
	modelItem.C
	partitioningItem.C
	pipeline.C
	plotter.C
	predictionItem.C
	predictionPlotter.C
	predictionResultDialog.C
	SDFInputDataItem.C
	SDFInputDialog.C
	validationDialog.C
	validationItem.C
	validationResultDialog.C
)

### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	componentPlotter.h
	connectionManager.h
	CSVInputDialog.h
	dataItem.h
	dataItemScene.h
	dataItemView.h
	featurePlotter.h
	featureSelectionDialog.h
	inputDataDialog.h
	inputDataItem.h
	inputPlotter.h
	mainWindow.h
	modelConfigurationDialog.h
	modelConfigurationDialogPages.h
	modelItem.h
	plotter.h
	predictionItem.h
	predictionResultDialog.h
	SDFInputDialog.h
	validationDialog.h
	validationItem.h
	validationResultDialog.h
)

#SET(RESOURCES_LIST
#	QuEasyViz.rc
#)

IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	# TODO: use individual icon for QuEasy
	LIST(APPEND RESOURCES_LIST ${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns)
	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns
			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
ENDIF()

QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
#QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
#QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR} ${Qwt5_INCLUDE_DIR})

IF (NOT Qwt5_Qt4_LIBRARY)
	MESSAGE(SEND_ERROR "Could not find Qwt5 library linked against Qt4!")
ENDIF()

ADD_EXECUTABLE(QuEasyViz
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
	${RESOURCES_LIST}
)

IF (WIN32)
	SET_TARGET_PROPERTIES(QuEasyViz PROPERTIES WIN32_EXECUTABLE TRUE)
ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	SET_TARGET_PROPERTIES(QuEasyViz PROPERTIES MACOSX_BUNDLE TRUE)
ENDIF()

TARGET_LINK_LIBRARIES(QuEasyViz ${VIEW_DEP_LIBRARIES} ${Qwt5_Qt4_LIBRARY})

INSTALL(TARGETS QuEasyViz
	COMPONENT "${COMPONENT_QUEASY}"
	RUNTIME DESTINATION "${BALL_RUNTIME_INSTALL_DIRECTORY}"
	BUNDLE DESTINATION "${BALL_BUNDLE_INSTALL_DIRECTORY}"
)

#INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/QuEasyViz 
#	DESTINATION "${BALL_DOCUMENTATION_INSTALL_DIRECTORY}" 
#	COMPONENT "${COMPONENT_QUEASY}"
#)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	GET_FILENAME_COMPONENT(MACDEPLOYQT_EXECUTABLE "${QT_QMAKE_EXECUTABLE}" PATH)
	SET(MACDEPLOYQT_EXECUTABLE "${MACDEPLOYQT_EXECUTABLE}/macdeployqt")
	INSTALL(CODE "SET(MACDEPLOYQT_EXECUTABLE \"${MACDEPLOYQT_EXECUTABLE}\")" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(FIXBUNDLE ${CMAKE_SOURCE_DIR}/MacOSX/fixbundleframeworks.sh)" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(BALLVIEW_BUNDLE \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${BALL_BUNDLE_INSTALL_DIRECTORY}/QuEasyViz.app\")" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(CMAKE_SOURCE_DIR ${CMAKE_SOURCE_DIR})" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(SCRIPT "${CMAKE_SOURCE_DIR}/cmake/BALLViewCreateBundle.cmake" COMPONENT "${COMPONENT_QUEASY}")
ENDIF()

TARGET_LINK_LIBRARIES(QuEasyViz BALL VIEW ${Qwt5_Qt4_LIBRARY})

=== source/APPLICATIONS/TOOLS/CMakeLists.txt ===
# The name of the project to build
PROJECT(ballaxy)

# We want a specific structure for our binary directories which suits galaxy...
SET(BALLAXY_TOOLS_DIR ${CMAKE_BINARY_DIR}/ballaxy/${CF_BALL_PACKAGE_VERSION}
	  CACHE PATH "Installation directory for ballaxy tools.")

SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/TOOLS/
	  CACHE PATH "Single output directory for building all executables.")

# Set BALL specific includes and compilerflags
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})
ADD_DEFINITIONS(${BALL_DEFINITIONS})
ADD_DEFINITIONS(${BALL_ADD_CXXFLAGS})

###### add TOOLS targets ########
SET(TOOLS_EXECUTABLES)
INCLUDE(sources.cmake)

FOREACH(i ${TOOLS_EXECUTABLES})
	ADD_EXECUTABLE(${i} ${i}.C)
	TARGET_LINK_LIBRARIES(${i} BALL)
	SET_PROPERTY(TARGET ${i} PROPERTY FOLDER TOOLS)
	INSTALL(TARGETS ${i}
		COMPONENT "${COMPONENT_TOOLS}"
		RUNTIME DESTINATION "${BALL_TOOLS_INSTALL_DIRECTORY}"
	)
ENDFOREACH(i)

CONFIGURE_FILE(
		"${CMAKE_SOURCE_DIR}/cmake/ballaxy/env.sh.in"
		"${CMAKE_BINARY_DIR}/ballaxy/${CF_BALL_PACKAGE_VERSION}/env.sh"
		@ONLY
)

CONFIGURE_FILE(
		"${CMAKE_SOURCE_DIR}/cmake/ballaxy/setupBALLAXYDirectories.cmake.in"
		"${PROJECT_BINARY_DIR}/cmake/setupBALLAXYDirectories.cmake"
		@ONLY
)

EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink 
	                 "${CMAKE_BINARY_DIR}/ballaxy/${CF_BALL_PACKAGE_VERSION}"
									 "${CMAKE_BINARY_DIR}/ballaxy/default")


ADD_CUSTOM_TARGET(ballaxy
	COMMAND ${CMAKE_COMMAND} -P "${PROJECT_BINARY_DIR}/cmake/setupBALLAXYDirectories.cmake"
)
ADD_DEPENDENCIES(ballaxy ${TOOLS_EXECUTABLES})

=== source/EXTENSIONS/BALLAXY/CMakeLists.txt ===
PROJECT(BALLAXY)

IF(NOT USE_QTWEBKIT)
	MESSAGE(STATUS "QtWebkit support has not been enabled. Disabling the BALLaxy plugin")
	RETURN()
ENDIF()

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(UI_SOURCES_LIST
	${DIRECTORY}/BALLaxyInterfacePreferences.ui
)

SET(SOURCES_LIST
	${DIRECTORY}/BALLaxyPlugin.C
	${DIRECTORY}/BALLaxyInterface.C
	${DIRECTORY}/BALLaxyInterfacePreferences.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/BALLaxyPlugin.h
	${DIRECTORY}/BALLaxyInterface.h
	${DIRECTORY}/BALLaxyInterfacePreferences.h
)

QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginBALLaxy SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginBALLaxy PROPERTIES
	PREFIX ""
)

INSTALL(TARGETS pluginBALLaxy
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginBALLaxy BALL VIEW)

=== source/EXTENSIONS/PRESENTABALL/CMakeLists.txt ===
PROJECT(PresentaBALL)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the PresentaBALL plugin.")
	RETURN()
ENDIF()

IF(NOT USE_QTWEBKIT)
	MESSAGE(STATUS "QtWebkit support has not been enabled. Disabling the PresentaBALL plugin.")
	RETURN()
ENDIF()

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(UI_SOURCES_LIST
	${DIRECTORY}/PresentaBALLSettings.ui
)

SET(SOURCES_LIST
	${DIRECTORY}/PresentaBALLPlugin.C
	${DIRECTORY}/PresentaBALLSettings.C
	${DIRECTORY}/HTMLBasedInterface.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/PresentaBALLPlugin.h
	${DIRECTORY}/PresentaBALLSettings.h
	${DIRECTORY}/HTMLBasedInterface.h
)

QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginPresentaBALL SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginPresentaBALL PROPERTIES
	PREFIX ""
)

INSTALL(TARGETS pluginPresentaBALL
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginPresentaBALL BALL VIEW)

=== source/EXTENSIONS/SPACENAV/CMakeLists.txt ===
PROJECT(SPACENAVIGATOR)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the SpaceNavigator plugin.")
	RETURN()
ENDIF()

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

FIND_PACKAGE(SpaceNavigator)

IF(NOT SPNAV_FOUND)
	MESSAGE(STATUS "Could not find SpaceNavigator libraries. Disabling the SpaceNavigator plugin")
	RETURN()
ENDIF()

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(SOURCES_LIST
	${DIRECTORY}/spaceNavigatorDriver.C
	${DIRECTORY}/spaceNavigatorPlugin.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/spaceNavigatorPlugin.h
)
#IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
#	LIST(APPEND RESOURCES_LIST ${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns)
#	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
#	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns
#			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
#ENDIF()


QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})
INCLUDE_DIRECTORIES(${SPNAV_INCLUDE_DIRS})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginSpaceNavigator SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginSpaceNavigator PROPERTIES PREFIX "")

INSTALL(TARGETS pluginSpaceNavigator
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginSpaceNavigator BALL VIEW ${SPNAV_LIBRARIES})

=== source/EXTENSIONS/VRPN/CMakeLists.txt ===
PROJECT(VRPN)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the VRPN plugin.")
	RETURN()
ENDIF()

FIND_PACKAGE(VRPN)

## VRPN
IF(NOT VRPN_FOUND)
	MESSAGE(STATUS "Could not find VRPN libraries. Disabling the VRPN plugin")
	RETURN()
ENDIF()

INCLUDE_DIRECTORIES(${VRPN_INCLUDE_DIR})

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(SOURCES_LIST
	${DIRECTORY}/VRPNPlugin.C
	${DIRECTORY}/VRPNDriver.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/VRPNPlugin.h
)

QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginVRPN SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginVRPN PROPERTIES PREFIX "")

INSTALL(TARGETS pluginVRPN
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginVRPN BALL VIEW ${VRPN_LIBRARY})

=== source/EXTENSIONS/VRPNHD/CMakeLists.txt ===
PROJECT(VRPNHD)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the VRPNHD plugin.")
	RETURN()
ENDIF()

FIND_PACKAGE(VRPN)

## VRPN
IF(NOT VRPN_FOUND)
	MESSAGE(STATUS "Could not find VRPN libraries. Disabling the VRPNHD plugin")
	RETURN()
ENDIF()

INCLUDE_DIRECTORIES(${VRPN_INCLUDE_DIR})

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(SOURCES_LIST
	${DIRECTORY}/VRPNHDPlugin.C
	${DIRECTORY}/VRPNHDDriver.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/VRPNHDPlugin.h
)

QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginVRPNHD SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginVRPNHD PROPERTIES PREFIX "")

INSTALL(TARGETS pluginVRPNHD
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginVRPNHD BALL VIEW ${VRPN_LIBRARY})

=== source/EXTENSIONS/XML3D/CMakeLists.txt ===
PROJECT(XML3D)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the XML3D plugin.")
	RETURN()
ENDIF()

IF(NOT BALL_PYTHON_SUPPORT)
	MESSAGE(STATUS "Python support has not been enabled. Disabling the XML3D plugin.")
	RETURN()
ENDIF()

FIND_PACKAGE(Loudmouth)
IF(NOT LIBLOUDMOUTH_FOUND)
	MESSAGE(STATUS "libloudmouth not found. Disabling the XML3D plugin.")
	RETURN()
ENDIF()
INCLUDE_DIRECTORIES(${LIBLOUDMOUTH_INCLUDE_DIR} ${LIBLOUDMOUTH_PKGCONF_INCLUDE_DIRS})

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(UI_SOURCES_LIST
	${DIRECTORY}/XML3DSettings.ui
	${DIRECTORY}/XMPPWidget.ui
)

SET(SOURCES_LIST
	${DIRECTORY}/XML3DDriver.C
	${DIRECTORY}/XML3DPlugin.C
	${DIRECTORY}/XML3DSettings.C
	${DIRECTORY}/XMPPWidget.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/XML3DPlugin.h
	${DIRECTORY}/XML3DSettings.h
	${DIRECTORY}/XMPPWidget.h
)
#IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
#	LIST(APPEND RESOURCES_LIST ${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns)
#	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
#	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns
#			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
#ENDIF()


QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginXML3D SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginXML3D PROPERTIES
	PREFIX ""
)

INSTALL(TARGETS pluginXML3D
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginXML3D BALL VIEW ${LIBLOUDMOUTH_LIBRARY})

=== debian/changelog ===
ball (1.4.3~beta1-3~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Really ignore errors (one occures on build machine

 -- Andreas Tille <tille@debian.org>  Fri, 17 Mar 2017 15:16:42 +0100

ball (1.4.3~beta1-3) unstable; urgency=medium

  * Ignore test suite result on non-amd64
    Closes: #830984

 -- Danny Edel <debian@danny-edel.de>  Sun, 13 Nov 2016 18:24:33 +0100

ball (1.4.3~beta1-2) unstable; urgency=medium

  [ Danny Edel ]
  * Team upload
  * Fix FTBFS with GCC-6 and recent boost
    Closes: #830984, #833004
    * Patches backported from upstream git:
      * 2822068 Modify RTTI function isKindOf to take a pointer argument
        (this fixes a segfault in DefaultProcessors_test)
      * 0604808 Fix PoseClustering_test: replace serialized file comparison
      * 7380918 Fix XDRPersistenceManager_test
    * New patch: disable AmberFF_test, which fails nondeterministically
  * Drop previous PoseClustering_test patches (no longer needed)
  * d/watch: fix uversionmangle expression to correctly detect -BETA

  [ Andreas Tille ]
  * Remove useless Breaks in python-ballview and python-ball
  * lintian override for package-name-doesnt-match-sonames

 -- Danny Edel <debian@danny-edel.de>  Fri, 11 Nov 2016 12:07:51 +0100

ball (1.4.3~beta1-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
    Closes: #777791
  * New homepage
  * Moved to Github
  * Adapt watch file to Github
  * Cherry-pick from upstream "Use c++11 on Clang"
  * Andreas Hildebrandt does not work on the packaging any more
  * cme fix dpkg-control
  * debian/rules: use dh
    Closes: #787888
  * debian/control: Drop *-dbg package since this is created automatically now
  * delete debian/menu
  * polish d/copyright
  * better hardening
  * cme fix dpkg-control
  * do not install empty directories for docs
  * do not repeat section field in d/control
  * doc package can be installed without main package -> only suggests main
    package
  * Use libjs-jquery instead of local copy pf jquery.js
  * DEP5 fixes
  * Use python-helper properly
  * Enhance long description of dev package
  * Use Breaks where Conflicts is to strong
  * Remove extra license file
  * Add lintian override for false positive package-contains-empty-directory

  [ Danny Edel ]
  * d/rules: Enable building and execution of unittests
  * Drop patch gcc5.diff (fixed upstream)
  * Backport patches from upstream git to fix FTBFS on recent sid:
    * b3679aa Fix: String failed to compile with newer GCC
    * 029fd2b Fix building PoseClustering with recent Boost
    * 3170b28 Fix compilation of BinaryFingerprintMethods_test
    * 7bb0166 Fixed PoseClustering test to account for changes in boost
    * 8ff1d1b FingerPrintSim: Fix build under clang 3.6 (also needed on gcc)
    * 38a955a Fix Python bindings for Box
    * f646875 Increased sleeping time on Socket_test
  * Add patches:
    * disable-assign-positions-from-template.patch
      (binary was only built, but not shipped previously, and fails to build
      with libeigen3-dev 3.3~beta1)
    * adjust-poseClustering_Test-boost-1.58.patch

 -- Andreas Tille <tille@debian.org>  Wed, 18 May 2016 14:49:09 +0200

ball (1.4.2+20140406-1.1) unstable; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Non-maintainer upload.
  * Remove qt4-related non-development build dependencies (Closes: #787746).
  * Force linking against libX11 with link_against_x11.patch. It seems that
    now we require to manually explicit it.
  * Add findsip.patch by Dmitry Shachnev to fix sip library detection.

  [ Matthias Klose ]
  * Fix some build errors with GCC 5 and clang++. Closes: #755225.
    Addresses #777791.
  * Build using dh-python. Closes: #785941.

 -- Matthias Klose <doko@debian.org>  Thu, 09 Jul 2015 12:17:06 +0200

=== debian/control ===
Source: ball
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Steffen Moeller <moeller@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-python,
               qt4-dev-tools,
               libqt4-dev,
               libqt4-opengl-dev,
               python-sip-dev,
               flex,
               bison,
               cmake,
               libqtwebkit-dev,
               libfftw3-dev,
               libeigen3-dev,
               libgsl0-dev,
               python-dev,
               libxrender-dev,
               libboost-dev,
               libboost-iostreams-dev,
               libboost-thread-dev,
               libboost-math-dev,
               libboost-system-dev,
               libasio-dev,
               libboost-regex-dev,
               libxmu-dev,
               libglew-dev,
               libx11-dev,
               tidy,
               chrpath,
               dh-python,
               libqt4-dev-bin
Build-Depends-Indep: doxygen,
                     graphviz,
                     ghostscript,
                     texlive-latex-base,
                     texlive-latex-recommended,
                     texlive-fonts-recommended,
                     texlive-latex-extra
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/ball.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/ball.git
Homepage: http://www.ball-project.org/
X-Python-Version: all

Package: libball1.4-data
Architecture: all
Depends: ${misc:Depends}
Description: Biochemical Algorithms Library (data files)
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the data files (force field parameters, fragment
 data bases, etc) necessary for using BALL.

Package: libball1.4
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libball1.4-data
Description: Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the view - independent parts of BALL (libBALL,
 data directories et al., except for libVIEW) and can be installed on
 machines without X11.

Package: libball1.4-dev
Architecture: any
Section: libdevel
Depends: libball1.4 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libball1.4-doc
Conflicts: libball1.3-dev
Description: Header files for the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package comprises the header files allowing to create
 one's own applications with the BALL library.

Package: libballview1.4
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Biochemical Algorithms Library, VIEW framework
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the view parts of BALL (libVIEW). Those are
 required for molecular visualization and for running BALLView.

Package: libballview1.4-dev
Architecture: any
Section: libdevel
Depends: libballview1.4 (= ${binary:Version}),
         ${misc:Depends}
Recommends: libball1.4-doc
Conflicts: libballview1.3-dev
Description: Header files for the VIEW part of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package comprises the header files allowing to create one's own 
 applications with the VIEW framework of the BALL library.

Package: python-ball
Architecture: any
Section: python
Depends: ${shlibs:Depends},
         ${python:Depends},
         ${sip:Depends},
         libball1.4,
         ${misc:Depends}
Description: Python bindings for the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package provides scripting access to the VIEW-independent functionality 
 of the Biochemical Algorithms Library (BALL).

Package: python-ballview
Architecture: any
Section: python
Depends: ${shlibs:Depends},
         ${python:Depends},
         ${sip:Depends},
         libball1.4,
         libballview1.4,
         python-ball (= ${binary:Version}),
         ${misc:Depends}
Description: Python bindings for VIEW-parts of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package provides scripting access to the VIEW-dependent functionality 
 of the Biochemical Algorithms Library (BALL).

Package: ballview
Architecture: any
Depends: ${shlibs:Depends},
         libball1.4,
         libballview1.4,
         python-ball,
         python-ballview,
         ${misc:Depends}
Description: free molecular modeling and molecular graphics tool
 BALLView provides fast OpenGL-based visualization of molecular structures, 
 molecular mechanics methods (minimization, MD simulation using the 
 AMBER, CHARMM, and MMFF94 force fields), calculation and visualization 
 of electrostatic properties (FDPB) and molecular editing features.
 .
 BALLView can be considered a graphical user interface on the basis of
 BALL (Biochemical Algorithms Library) with a focus on the most common
 demands of protein chemists and biophysicists in particular.  It is
 developed in the groups of Hans-Peter Lenhof (Saarland University,
 Saarbruecken, Germany) and Oliver Kohlbacher (University of Tuebingen,
 Germany). BALL is an application framework in C++ that has been
 specifically designed for rapid software development in Molecular
 Modeling and Computational Molecular Biology.  It provides an extensive
 set of data structures as well as classes for Molecular Mechanics,
 advanced solvation methods, comparison and analysis of protein
 structures, file import/export, and visualization.

Package: libball1.4-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Suggests: libball1.4
Conflicts: libball1.3-doc
Description: documentation for the BALL library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 The package comprises an extensive manual on how to program molecular
 modelling programs with BALL.

=== debian/rules ===
#!/usr/bin/make -f 
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

SOVERSION=1.4
BALL_INSTALL_PATH=build
PYTHON_VERSION=2.6
PYTHON_SITE_PATH=$(shell python -c "import distutils.sysconfig; print distutils.sysconfig.get_python_lib(0,0)[4:];")

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --builddirectory=build --with python2

override_dh_auto_configure:
	mkdir -p build
	cd build && LDFLAGS="$(LDFLAGS)" CXXFLAGS="$(CXXFLAGS)" CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" \
	            cmake .. -DCMAKE_SOURCE_DIR=$(CURDIR) -DCMAKE_INSTALL_PREFIX=./usr -DBALL_PATH=/usr -DBALL_DATA_PATH=/usr/share/BALL-$(SOVERSION)/data

# Set BALL_DATA_PATH so that test scripts find it
export BALL_DATA_PATH=$(CURDIR)/data
# Make sure HOME exists (for Directory_test)
export HOME=/tmp

# Disable test for arch-indep builds
override_dh_auto_test-indep:


# The testsuite fails on almost any non-amd64 port.
# Run it, but ignore the return code for now.
#
# TODO: Improve the portability of code and testsuite.
ifndef DEB_HOST_ARCH
$(warning DEB_HOST_ARCH is not defined.  I don't know which \
architecture I'm supposed to build for.  \
Expect "interesting" results.)
else ifneq ($(DEB_HOST_ARCH),amd64)
$(warning Building for $(DEB_HOST_ARCH) which is not amd64.  \
We will run the test suite, but ignore any errors to prevent FTBFS.  \
See Debian bug #830894 for the discussion and how you can help.\
)
override_dh_auto_test-arch:
	dh_auto_test || true
endif


override_dh_auto_build-arch:
	## Fix upstream issue of missing UI files
	uic-qt4 source/VIEW/DIALOGS/assignBondOrderConfigurationDialog.ui > include/BALL/VIEW/UIC/ui_assignBondOrderConfigurationDialog.h
	uic-qt4 source/VIEW/DIALOGS/assignBondOrderResultsDialog.ui       > include/BALL/VIEW/UIC/ui_assignBondOrderResultsDialog.h
	uic-qt4 source/VIEW/DIALOGS/atomOverview.ui                       > include/BALL/VIEW/UIC/ui_atomOverview.h
	## ...
	## Uhmmm, seems we need to do this for all UI files mentioned in
	##   source/VIEW/DIALOGS/sources.cmake
	## but I really hope some cmake expert might be able to find a clue
	## how to trigger cmake to do it as intended by upstream.
	## Somehow the code
	##   ADD_BALL_UIFILES("VIEW/DIALOGS" "${UI_LIST}")
	## needs to be called before the build code below can be started
	make -C build BALL VIEW BALLView build_tests install

override_dh_auto_build-indep:
	make -C build doc doc_tutorial install

override_dh_auto_clean:
	[ -d source ] && cd source ; \
	if [ -f Makefile ] ; \
	then  \
		make clean ; \
		cd PYTHON/EXTENSIONS; \
		make clean; \
		rm -rf ../lib/Linux*; \
		rm -rf ../doc/doxygen/latex/*; \
		rm -f $(CURDIR)/source/config.status 2>/dev/null; \
	fi
	rm -f data/BALLView/translations/BALLView.de_DE.qm
	rm -f data/BALLView/translations/BALLView.zh_TW.qm
	rm -f doc/TUTORIAL/*.aux
	rm -rf $(BALL_INSTALL_PATH)
	find . -name "*.o" | xargs -r rm
	find . -type l | xargs -r rm
	find doc/TUTORIAL/ -name "tutorial.*" | egrep -v ".(tex|bib)$$" |xargs -r rm
	rm -f include/BALL/BALL.doc
	# find . -name "*.doc" -delete
	# Remove self-create UI header file
	rm -f include/BALL/VIEW/UIC/ui_assignBondOrderConfigurationDialog.h \
	      include/BALL/VIEW/UIC/ui_assignBondOrderResultsDialog.h \
	      include/BALL/VIEW/UIC/ui_atomOverview.h


override_dh_auto_install-arch:
	mkdir -p debian/libball$(SOVERSION)/usr/lib \
		debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION) \
		debian/libballview$(SOVERSION)/usr/lib \
		debian/python-ball/usr/share/BALL-$(SOVERSION) \
		debian/python-ball/usr/$(PYTHON_SITE_PATH) \
		debian/python-ballview/usr/$(PYTHON_SITE_PATH)

	mkdir -p debian/ballview/usr/share/BALL-$(SOVERSION)/data/graphics

	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/BALLView/* debian/ballview/usr/share/doc/ballview/html
	cp    $(BALL_INSTALL_PATH)/usr/bin/BALLView		 debian/ballview/usr/bin/

	find $(BALL_INSTALL_PATH)/usr/lib/ -name libBALL*.so.* | xargs -r cp --target-directory debian/libball$(SOVERSION)/usr/lib/
	find $(BALL_INSTALL_PATH)/usr/lib/ -name libVIEW*.so.* | xargs -r cp --target-directory debian/libballview$(SOVERSION)/usr/lib/

	# debian needs the logo in the ballview - package, not in the libball
	cp $(BALL_INSTALL_PATH)/usr/share/BALL/data/graphics/ballview*.xpm debian/ballview/usr/share/pixmaps/

	cp -r source/EXAMPLES/PYTHON    debian/python-ball/usr/share/BALL-$(SOVERSION)
	cp $(BALL_INSTALL_PATH)/usr/lib/BALL.py       debian/python-ball/usr/$(PYTHON_SITE_PATH)
	cp $(BALL_INSTALL_PATH)/usr/lib/BALLCore.so   debian/python-ball/usr/$(PYTHON_SITE_PATH)
	cp $(BALL_INSTALL_PATH)/usr/lib/VIEW.so       debian/python-ballview/usr/$(PYTHON_SITE_PATH)

	chmod ugo-x debian/python-ball/usr/share/BALL-$(SOVERSION)/PYTHON/UTILITIES/*.py
	chmod ugo-x debian/python-ball/usr/share/BALL-$(SOVERSION)/PYTHON/BALLView/*.py
	chmod ugo-x debian/python-ball/usr/share/BALL-$(SOVERSION)/PYTHON/howtos/*.py

	# -dev packages are arch dependent
	mkdir -p debian/libball$(SOVERSION)-dev/usr/lib \
		debian/libballview$(SOVERSION)-dev/usr/include/BALL \
		debian/libballview$(SOVERSION)-dev/usr/lib \
		debian/libball$(SOVERSION)-dev/usr/include
	# move the cmake configuration files to their final location
	cp -R $(BALL_INSTALL_PATH)/usr/lib/cmake/ debian/libball$(SOVERSION)-dev/usr/lib

	cp -r $(BALL_INSTALL_PATH)/usr/include/BALL       debian/libball$(SOVERSION)-dev/usr/include
	cp -r $(BALL_INSTALL_PATH)/usr/include/BALL/VIEW  debian/libballview$(SOVERSION)-dev/usr/include/BALL

	# get rid of the VIEW includes in libball-dev
	rm -rf debian/libball$(SOVERSION)-dev/usr/include/BALL/VIEW

	# eliminating chrpath settings
	chmod 755 debian/ballview/usr/bin/BALLView
	chrpath -d debian/ballview/usr/bin/BALLView
	find debian -name "*.so" | xargs -r chrpath -d 

override_dh_auto_install-indep:
	mkdir -p debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/html \
		debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc

	cp    $(BALL_INSTALL_PATH)/usr/share/BALL/doc/TUTORIAL/tutorial.pdf   debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/
	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/classes                 debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/internal                debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
	# we need the BALLView documentation in the data path as well... sorry for that
	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/BALLView debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/BALL     debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/html

	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/data    debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION) 

override_dh_installdocs:
	dh_installdocs
	find debian/*/usr/share -type d -empty -delete
	find debian/*/usr/share -name jquery.js -delete
	find debian/*/usr/share -name license.txt -delete

=== debian/watch ===
version=3
opts=uversionmangle=s/_/./g;s/-BETA/~beta/ \
  https://github.com/BALL-Project/ball/releases .*/archive/V(\d[-\d._BETA]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
